"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigListComponent = void 0;
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var configuracion_service_1 = require("../shared/service/configuracion.service");
var config_filter_1 = require("../shared/data/config.filter");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var message_service_1 = require("../../shared/service/message.service");
var general_utils_service_1 = require("../../shared/service/general-utils.service");
var tableview_service_1 = require("../../shared/service/tableview.service");
var base_list_component_1 = require("../../base/component/base-list.component");
var bit_toolbar_component_1 = require("../../shared/component/bit-toolbar.component");
var i0 = require("@angular/core");
var i1 = require("../shared/service/configuracion.service");
var i2 = require("../../shared/service/message.service");
var i3 = require("../../shared/service/toolbar.service");
var i4 = require("@angular/router");
var i5 = require("../../shared/service/general-utils.service");
var i6 = require("../../shared/service/tableview.service");
var i7 = require("../../shared/component/bit-header.component");
var i8 = require("./config-list-tableview.component");
var i9 = require("../../shared/component/bit-footer.component");
var ConfigListComponent = /** @class */ (function (_super) {
    __extends(ConfigListComponent, _super);
    function ConfigListComponent(configService, messageService, toolbarService, activatedRoute, router, generalUtils, tableViewService) {
        var _this = _super.call(this, configService, messageService, activatedRoute, router, toolbarService, "BASE", generalUtils, tableViewService) || this;
        _this.configService = configService;
        _this.messageService = messageService;
        _this.toolbarService = toolbarService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.generalUtils = generalUtils;
        _this.tableViewService = tableViewService;
        _this.breadcrumb.push({ label: "Desenvolupament" });
        _this.breadcrumb.push({ label: "Configuració" });
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas */
    ConfigListComponent.prototype.ngOnInit = function () {
        _super.prototype.init.call(this, config_filter_1.ConfigFilter.newObject());
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON].enable = true;
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON].visible = true;
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON].estilo = "fa fa-database";
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.EXPORT_BUTTON].enable = true;
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.EXPORT_BUTTON].visible = true;
        this.updateToolbar();
        //this.search(false); // no hay filtro ni paginación, buscamos nada más entrar
        this.items = [
            { codigo: 1, valor: "variable1" },
            { codigo: 2, valor: "variable2" },
            { codigo: 3, valor: "variable3" }
        ];
    };
    ConfigListComponent.prototype.prepareDataForSubmit = function () { };
    ConfigListComponent.ɵfac = function ConfigListComponent_Factory(t) { return new (t || ConfigListComponent)(i0.ɵɵdirectiveInject(i1.ConfiguracionService), i0.ɵɵdirectiveInject(i2.MessageService), i0.ɵɵdirectiveInject(i3.ToolbarService), i0.ɵɵdirectiveInject(i4.ActivatedRoute), i0.ɵɵdirectiveInject(i4.Router), i0.ɵɵdirectiveInject(i5.GeneralUtils), i0.ɵɵdirectiveInject(i6.TableViewService)); };
    ConfigListComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ConfigListComponent, selectors: [["config-list"]], features: [i0.ɵɵInheritDefinitionFeature], decls: 3, vars: 6, consts: [[3, "breadcrumb", "onToolbarButtonPressed"], [3, "items"], ["type", "list", 3, "autoQueryObs", "totalItems", "status", "paginator", "onPageChange", "onNewPageSize"]], template: function ConfigListComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "bit-header", 0);
            i0.ɵɵlistener("onToolbarButtonPressed", function ConfigListComponent_Template_bit_header_onToolbarButtonPressed_0_listener($event) { return ctx.onToolbarButtonPressed($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelement(1, "config-list-tableview", 1);
            i0.ɵɵelementStart(2, "bit-footer", 2);
            i0.ɵɵlistener("onPageChange", function ConfigListComponent_Template_bit_footer_onPageChange_2_listener($event) { return ctx.onPageChange($event); })("onNewPageSize", function ConfigListComponent_Template_bit_footer_onNewPageSize_2_listener($event) { return ctx.onNewPageSize($event); });
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("breadcrumb", ctx.breadcrumb);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("items", ctx.items);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("autoQueryObs", ctx.autoQuerySubject.asObservable())("totalItems", ctx.totalItems)("status", ctx.status)("paginator", true);
        } }, directives: [i7.BitHeaderComponent, i8.ConfigListTableViewComponent, i9.BitFooterComponent], encapsulation: 2 });
    return ConfigListComponent;
}(base_list_component_1.BaseListComponent));
exports.ConfigListComponent = ConfigListComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ConfigListComponent, [{
        type: core_1.Component,
        args: [{
                selector: "config-list",
                template: "\n    <bit-header [breadcrumb]=\"breadcrumb\" (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n    <config-list-tableview [items]=\"items\"></config-list-tableview>\n    <bit-footer\n      [autoQueryObs]=\"autoQuerySubject.asObservable()\"\n      [totalItems]=\"totalItems\"\n      [status]=\"status\"\n      type=\"list\"\n      [paginator]=\"true\"\n      (onPageChange)=\"onPageChange($event)\"\n      (onNewPageSize)=\"onNewPageSize($event)\"\n    ></bit-footer>\n  "
            }]
    }], function () { return [{ type: i1.ConfiguracionService }, { type: i2.MessageService }, { type: i3.ToolbarService }, { type: i4.ActivatedRoute }, { type: i4.Router }, { type: i5.GeneralUtils }, { type: i6.TableViewService }]; }, null); })();
//# sourceMappingURL=config-list.component.js.map