"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfiguracionService = void 0;
var core_1 = require("@angular/core");
var base_service_1 = require("../../../base/shared/base.service");
var http_utils_service_1 = require("../../../shared/service/http-utils.service");
var message_service_1 = require("../../../shared/service/message.service");
var domain_cached_service_1 = require("../../../shared/service/domain-cached.service");
var session_shared_service_1 = require("../../../shared/service/session-shared.service");
var i0 = require("@angular/core");
var i1 = require("../../../shared/service/message.service");
var i2 = require("../../../shared/service/http-utils.service");
var i3 = require("../../../shared/service/domain-cached.service");
var i4 = require("../../../shared/service/session-shared.service");
/**
 Servicio que devuelve parámetros de configuración.
 */
var ConfiguracionService = /** @class */ (function (_super) {
    __extends(ConfiguracionService, _super);
    function ConfiguracionService(messageService, http, domainService, sessionShared) {
        var _this = _super.call(this, messageService, http) || this;
        _this.messageService = messageService;
        _this.http = http;
        _this.domainService = domainService;
        _this.sessionShared = sessionShared;
        _this.baseUrl = ConfiguracionService.STATIC_URL;
        return _this;
    }
    ConfiguracionService.prototype.getAllConfiguracion = function () {
        return this.domainService.getDominio("configuracion");
    };
    ConfiguracionService.STATIC_URL = "configuracion";
    ConfiguracionService.ɵfac = function ConfiguracionService_Factory(t) { return new (t || ConfiguracionService)(i0.ɵɵinject(i1.MessageService), i0.ɵɵinject(i2.HttpUtilsService), i0.ɵɵinject(i3.DomainCachedService), i0.ɵɵinject(i4.SessionSharedService)); };
    ConfiguracionService.ɵprov = i0.ɵɵdefineInjectable({ token: ConfiguracionService, factory: ConfiguracionService.ɵfac });
    return ConfiguracionService;
}(base_service_1.BaseCRUDService));
exports.ConfiguracionService = ConfiguracionService;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ConfiguracionService, [{
        type: core_1.Injectable
    }], function () { return [{ type: i1.MessageService }, { type: i2.HttpUtilsService }, { type: i3.DomainCachedService }, { type: i4.SessionSharedService }]; }, null); })();
//# sourceMappingURL=configuracion.service.js.map