"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BitControlMessages = void 0;
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var custom_validators_service_1 = require("../service/custom-validators.service");
var focus_service_1 = require("../service/focus.service");
var i0 = require("@angular/core");
var i1 = require("../service/focus.service");
var i2 = require("@angular/common");
function BitControlMessages_div_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div");
    i0.ɵɵelementStart(1, "span", 1);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(ctx_r0.errorMessage);
} }
//inputs: ['control: control', 'onField: onField'],
var BitControlMessages = /** @class */ (function () {
    //constructor( @Host() private formDir: FormGroup) { }
    function BitControlMessages(focusService) {
        this.focusService = focusService;
    }
    Object.defineProperty(BitControlMessages.prototype, "errorMessage", {
        get: function () {
            if (this.focusService.getFocusedElement() !== this.field) {
                for (var propertyName in this.control.errors) {
                    // If control has a error
                    if (this.control.errors.hasOwnProperty(propertyName) && this.control.touched) {
                        // Return the appropriate error message from the Validation Service
                        return custom_validators_service_1.CustomValidators.getValidatorErrorMessage(propertyName);
                    }
                }
                return null;
            }
        },
        enumerable: false,
        configurable: true
    });
    BitControlMessages.ɵfac = function BitControlMessages_Factory(t) { return new (t || BitControlMessages)(i0.ɵɵdirectiveInject(i1.FocusService)); };
    BitControlMessages.ɵcmp = i0.ɵɵdefineComponent({ type: BitControlMessages, selectors: [["control-messages"]], inputs: { control: "control", field: "field" }, decls: 1, vars: 1, consts: [[4, "ngIf"], [1, "mensaje-error-input"]], template: function BitControlMessages_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵtemplate(0, BitControlMessages_div_0_Template, 3, 1, "div", 0);
        } if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.errorMessage !== null);
        } }, directives: [i2.NgIf], encapsulation: 2 });
    return BitControlMessages;
}());
exports.BitControlMessages = BitControlMessages;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BitControlMessages, [{
        type: core_1.Component,
        args: [{
                selector: "control-messages",
                template: "\n    <div *ngIf=\"errorMessage !== null\">\n      <span class=\"mensaje-error-input\">{{ errorMessage }}</span>\n    </div>\n  "
            }]
    }], function () { return [{ type: i1.FocusService }]; }, { control: [{
            type: core_1.Input
        }], field: [{
            type: core_1.Input
        }] }); })();
//# sourceMappingURL=bit-control-messages.component.js.map