import { Observable } from "rxjs";
import { BaseCRUDService } from "../../base/shared/base.service";
import { Domain } from "../data/domain";
import { HttpUtilsService } from "../service/http-utils.service";
import { MessageService } from "../service/message.service";
import * as i0 from "@angular/core";
export declare class DomainService extends BaseCRUDService {
    protected messageService: MessageService;
    protected http: HttpUtilsService;
    private getDominiosBaseUrl;
    constructor(messageService: MessageService, http: HttpUtilsService);
    /**TODO: reconstruir cada elemento de id, valor a label, value */
    getDominio(dominio: string, params?: string[]): Observable<Domain[]>;
    static ɵfac: i0.ɵɵFactoryDef<DomainService, never>;
    static ɵprov: i0.ɵɵInjectableDef<DomainService>;
}
