import * as i0 from "@angular/core";
export declare class UploadService {
    private apiUrl;
    private UPLOAD_URL;
    private DOWNLOAD_URL;
    constructor(apiUrl: string);
    /**
     * servicio para hacer upload de ficheros al servidor
     * @param url indica la URL a la que queremos subir el fichero. Si es null se utilizará el endpoint por defecto definido en UPLOAD_URL
     * @param files fichero(s) a subir al servidor
     * @param params parámetros adicionales en forma de Map para hacer la subida
     */
    upload(url: string, files: Array<File>, params: {
        [key: string]: string;
    }): Promise<unknown>;
    getUrlDownloadFile(id: number): string;
    static ɵfac: i0.ɵɵFactoryDef<UploadService, never>;
    static ɵprov: i0.ɵɵInjectableDef<UploadService>;
}
