import { Router, ActivatedRoute } from "@angular/router";
import { Item } from "../../shared/data/item";
import { BaseTableViewComponent } from "../../base/index";
import { DomainCachedService, TableViewService } from "../../shared/index";
import * as i0 from "@angular/core";
export declare class ConfigListTableViewComponent extends BaseTableViewComponent {
    protected domainCachedService: DomainCachedService;
    protected tableViewService: TableViewService;
    private router;
    protected activatedRoute: ActivatedRoute;
    items: Item[];
    cols: any[];
    constructor(domainCachedService: DomainCachedService, tableViewService: TableViewService, router: Router, activatedRoute: ActivatedRoute);
    gotoForm(event: any): void;
    static ɵfac: i0.ɵɵFactoryDef<ConfigListTableViewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ConfigListTableViewComponent, "config-list-tableview", never, { "items": "items"; }, {}, never, never>;
}
