"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogService = void 0;
var core_1 = require("@angular/core");
var http_utils_service_1 = require("../../../shared/service/http-utils.service");
var message_service_1 = require("../../../shared/service/message.service");
var base_service_1 = require("../../../base/shared/base.service");
var i0 = require("@angular/core");
var i1 = require("../../../shared/service/message.service");
var i2 = require("../../../shared/service/http-utils.service");
var LogService = /** @class */ (function (_super) {
    __extends(LogService, _super);
    function LogService(messageService, http) {
        var _this = _super.call(this, messageService, http) || this;
        _this.messageService = messageService;
        _this.http = http;
        _this.countAllLogsByFilterUrl = "logs/count";
        _this.getAllLogsByFilterUrl = "logs/filter";
        _this.getDominiosLogUrl = "dominios/tipolog";
        return _this;
    }
    LogService.prototype.getAllByFilter = function (logFilter) {
        return this.http.getHttpPost(this.getAllLogsByFilterUrl, logFilter);
    };
    LogService.prototype.countAllByFilter = function (logFilter) {
        return this.http.getHttpPost(this.countAllLogsByFilterUrl, logFilter);
    };
    LogService.ɵfac = function LogService_Factory(t) { return new (t || LogService)(i0.ɵɵinject(i1.MessageService), i0.ɵɵinject(i2.HttpUtilsService)); };
    LogService.ɵprov = i0.ɵɵdefineInjectable({ token: LogService, factory: LogService.ɵfac });
    return LogService;
}(base_service_1.BaseCRUDService));
exports.LogService = LogService;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LogService, [{
        type: core_1.Injectable
    }], function () { return [{ type: i1.MessageService }, { type: i2.HttpUtilsService }]; }, null); })();
//# sourceMappingURL=log.service.js.map