import { EventEmitter } from "@angular/core";
import { Fichero } from "../data/fichero";
import { UploadService } from "../service/upload.service";
import { MessageService } from "../service/message.service";
import * as i0 from "@angular/core";
export declare class BitFormUploadComponent {
    private uploadService;
    protected messageService: MessageService;
    private downloadUrlVariable;
    params: {
        [key: string]: string;
    };
    showFiles: boolean;
    id: string;
    multiple: boolean;
    searchLabel: string;
    soloLectura: boolean;
    simpleFile: Fichero;
    fileList: Array<Fichero>;
    puedeAbrir: boolean;
    private onFilesUpload;
    uploading: boolean;
    private filesToUpload;
    resetUpload: EventEmitter<any>;
    private static DOWNLOAD_URL;
    constructor(uploadService: UploadService, messageService: MessageService, downloadUrlVariable: string);
    ngOnInit(): void;
    fileChange(files: Array<File>): void;
    downloadUrl(id: number): string;
    static getUrlDownloadFile(id: number): string;
    submit(): void;
    static createNewParamsObject(tipoFichero: string): {
        [key: string]: string;
    };
    static addCarpetaToParamsObject(paramsUploadFile: {
        [key: string]: string;
    }, carpeta: string): void;
    static addIdToParamsObject(paramsUploadFile: {
        [key: string]: string;
    }, id: string): void;
    static addTipoFicheroToParamsObject(paramsUploadFile: {
        [key: string]: string;
    }, tipoFichero: string): void;
    static ɵfac: i0.ɵɵFactoryDef<BitFormUploadComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<BitFormUploadComponent, "bit-form-upload", never, { "params": "params"; "showFiles": "showFiles"; "id": "id"; "multiple": "multiple"; "searchLabel": "searchLabel"; "soloLectura": "soloLectura"; "simpleFile": "simpleFile"; "fileList": "fileList"; "puedeAbrir": "puedeAbrir"; }, { "onFilesUpload": "onFilesUpload"; }, never, never>;
}
