"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BitHeaderComponent = void 0;
var core_1 = require("@angular/core");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
var i2 = require("./bit-breadcrumb.component");
var i3 = require("./bit-toolbar.component");
function BitHeaderComponent_bit_breadcrumb_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "bit-breadcrumb", 4);
} if (rf & 2) {
    var ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("breadcrumb", ctx_r0.breadcrumb);
} }
var _c0 = function (a0) { return [a0]; };
function BitHeaderComponent_div_3_Template(rf, ctx) { if (rf & 1) {
    var _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 1);
    i0.ɵɵelementStart(1, "bit-toolbar", 5);
    i0.ɵɵlistener("onToolbarButtonPressed", function BitHeaderComponent_div_3_Template_bit_toolbar_onToolbarButtonPressed_1_listener($event) { i0.ɵɵrestoreView(_r3); var ctx_r2 = i0.ɵɵnextContext(); return ctx_r2.onTBPressed($event); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(5, _c0, ctx_r1.colsBreadcrumb ? "col-sm-" + (12 - ctx_r1.colsBreadcrumb) : ctx_r1.masacciones ? "col-sm-7" : "col-sm-5"));
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("componentId", ctx_r1.componentId)("femenino", ctx_r1.femenino)("otherActionsDropdown", ctx_r1.otherActionsDropdown)("ayuda", ctx_r1.ayuda);
} }
/**
 * Componente que muestra miga de pan y toolbar
 */
var BitHeaderComponent = /** @class */ (function () {
    function BitHeaderComponent() {
        this.componentId = "BASE"; //id del componente donde está asociado el header. Por defecto BASE
        this.toolbar = {};
        this.noToolbar = false;
        this.otherActionsDropdown = false; // determina si las "other actions" deben mostrarse en línea o como un desplegable
        this.femenino = false; // género femenino (para los nombres de botones) o no
        this.onToolbarButtonPressed = new core_1.EventEmitter();
    }
    /** Tenemos que capturar el evento y volver a subirlo, por diseño Angular2 no permite enviar un evento de un nieto a su abuelo, solo
     * de hijo a padre
     */
    BitHeaderComponent.prototype.onTBPressed = function (button) {
        this.onToolbarButtonPressed.emit(button);
    };
    BitHeaderComponent.ɵfac = function BitHeaderComponent_Factory(t) { return new (t || BitHeaderComponent)(); };
    BitHeaderComponent.ɵcmp = i0.ɵɵdefineComponent({ type: BitHeaderComponent, selectors: [["bit-header"]], inputs: { componentId: "componentId", toolbar: "toolbar", noToolbar: "noToolbar", otherActionsDropdown: "otherActionsDropdown", breadcrumb: "breadcrumb", masacciones: "masacciones", colsBreadcrumb: "colsBreadcrumb", femenino: "femenino", ayuda: "ayuda" }, outputs: { onToolbarButtonPressed: "onToolbarButtonPressed" }, decls: 4, vars: 9, consts: [[1, "row", "container"], [3, "ngClass"], [3, "breadcrumb", 4, "ngIf"], [3, "ngClass", 4, "ngIf"], [3, "breadcrumb"], [3, "componentId", "femenino", "otherActionsDropdown", "ayuda", "onToolbarButtonPressed"]], template: function BitHeaderComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵelementStart(1, "div", 1);
            i0.ɵɵtemplate(2, BitHeaderComponent_bit_breadcrumb_2_Template, 1, 1, "bit-breadcrumb", 2);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(3, BitHeaderComponent_div_3_Template, 2, 7, "div", 3);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵclassProp("container-bread-btn-fixed", ctx.breadcrumb)("cotainer-bread-btn-lite", !ctx.breadcrumb);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(7, _c0, ctx.colsBreadcrumb ? "col-sm-" + ctx.colsBreadcrumb : ctx.masacciones ? "col-sm-5" : "col-sm-7"));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.breadcrumb);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.noToolbar === false);
        } }, directives: [i1.NgClass, i1.NgIf, i2.BitBreadCrumbComponent, i3.BitToolbarComponent], encapsulation: 2 });
    return BitHeaderComponent;
}());
exports.BitHeaderComponent = BitHeaderComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BitHeaderComponent, [{
        type: core_1.Component,
        args: [{
                selector: "bit-header",
                template: "\n    <div\n      class=\"row container\"\n      [class.container-bread-btn-fixed]=\"breadcrumb\"\n      [class.cotainer-bread-btn-lite]=\"!breadcrumb\"\n    >\n      <div [ngClass]=\"[colsBreadcrumb ? 'col-sm-' + colsBreadcrumb : masacciones ? 'col-sm-5' : 'col-sm-7']\">\n        <!-- ruta de donde nos encontramos (miga de pan) -->\n        <bit-breadcrumb *ngIf=\"breadcrumb\" [breadcrumb]=\"breadcrumb\"></bit-breadcrumb>\n      </div>\n      <div\n        *ngIf=\"noToolbar === false\"\n        [ngClass]=\"[colsBreadcrumb ? 'col-sm-' + (12 - colsBreadcrumb) : masacciones ? 'col-sm-7' : 'col-sm-5']\"\n      >\n        <!-- botonera de acciones -->\n        <bit-toolbar\n          [componentId]=\"componentId\"\n          [femenino]=\"femenino\"\n          [otherActionsDropdown]=\"otherActionsDropdown\"\n          [ayuda]=\"ayuda\"\n          (onToolbarButtonPressed)=\"onTBPressed($event)\"\n        ></bit-toolbar>\n      </div>\n    </div>\n  "
            }]
    }], null, { componentId: [{
            type: core_1.Input
        }], toolbar: [{
            type: core_1.Input
        }], noToolbar: [{
            type: core_1.Input
        }], otherActionsDropdown: [{
            type: core_1.Input
        }], breadcrumb: [{
            type: core_1.Input
        }], masacciones: [{
            type: core_1.Input
        }], colsBreadcrumb: [{
            type: core_1.Input
        }], femenino: [{
            type: core_1.Input
        }], ayuda: [{
            type: core_1.Input
        }], onToolbarButtonPressed: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=bit-header.component.js.map