import { OnDestroy } from "@angular/core";
import { Message } from "primeng/api";
import { MessageService } from "../service/message.service";
import { MessageService as PrimeMessageService } from "primeng/api";
import { BitMessage } from "../data/bitmessage";
import { Error } from "../data/error";
import * as i0 from "@angular/core";
export declare class BitNotificationComponent implements OnDestroy {
    protected primeMessageService: PrimeMessageService;
    notificationMessages: Message[];
    errorMessages: Message[];
    static MENSAJE_VOID: string;
    private subscriptionNotifications;
    private subscriptionNotificationsErrors;
    constructor(messageService: MessageService, primeMessageService: PrimeMessageService);
    showMessage(message: BitMessage): void;
    showNotificationError(notificationError: Error): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDef<BitNotificationComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<BitNotificationComponent, "bit-notification", never, {}, {}, never, never>;
}
