"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BitUserControlsComponent = void 0;
var core_1 = require("@angular/core");
var i0 = require("@angular/core");
var i1 = require("@angular/common");
function BitUserControlsComponent_span_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 1);
    i0.ɵɵelement(1, "span", 2);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵpropertyInterpolate("title", ctx_r0.json);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate2("\u00A0\u00A0", ctx_r0.usuario.nombreCompleto, " (", ctx_r0.usuario.login, ")\u00A0\u00A0");
} }
/**
 * Componente general que muestra controles de sesión de usuario.
 *
 * Informa del login actualmente en sesión
 */
var BitUserControlsComponent = /** @class */ (function () {
    function BitUserControlsComponent() {
    }
    Object.defineProperty(BitUserControlsComponent.prototype, "json", {
        get: function () {
            return this.usuario && JSON.stringify(this.usuario, null, 4);
        },
        enumerable: false,
        configurable: true
    });
    BitUserControlsComponent.ɵfac = function BitUserControlsComponent_Factory(t) { return new (t || BitUserControlsComponent)(); };
    BitUserControlsComponent.ɵcmp = i0.ɵɵdefineComponent({ type: BitUserControlsComponent, selectors: [["bit-user-controls"]], inputs: { usuario: "usuario" }, decls: 1, vars: 1, consts: [["class", "userControls", 4, "ngIf"], [1, "userControls"], [1, "fa", "fa-user", 3, "title"]], template: function BitUserControlsComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵtemplate(0, BitUserControlsComponent_span_0_Template, 3, 3, "span", 0);
        } if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.usuario);
        } }, directives: [i1.NgIf], encapsulation: 2 });
    return BitUserControlsComponent;
}());
exports.BitUserControlsComponent = BitUserControlsComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BitUserControlsComponent, [{
        type: core_1.Component,
        args: [{
                selector: "bit-user-controls",
                template: "\n    <span *ngIf=\"usuario\" class=\"userControls\"\n      ><span class=\"fa fa-user\" title=\"{{ json }}\"></span>&nbsp;&nbsp;{{ usuario.nombreCompleto }} ({{\n        usuario.login\n      }})&nbsp;&nbsp;</span\n    >\n  "
            }]
    }], function () { return []; }, { usuario: [{
            type: core_1.Input
        }] }); })();
//# sourceMappingURL=bit-user-controls.component.js.map