"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.BitCalendarComponent = void 0;
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var ayuda_service_1 = require("../../service/ayuda.service");
var bit_custom_component_1 = require("./bit-custom.component");
var i0 = require("@angular/core");
var i1 = require("../../service/ayuda.service");
/** Clase general para componentes personalizados de tipo Fecha como puede ser BitDate, BitTime y BitDateTime */
var BitCalendarComponent = /** @class */ (function (_super) {
    __extends(BitCalendarComponent, _super);
    function BitCalendarComponent(ayudaService, changeDetectorRef) {
        var _this = _super.call(this, ayudaService, changeDetectorRef) || this;
        _this.ayudaService = ayudaService;
        _this.changeDetectorRef = changeDetectorRef;
        _this.rangoAnyoMinimo = "2000";
        _this.rangoAnyoMaximo = "2030";
        _this.LOCALE_ES = {
            firstDayOfWeek: 1,
            closeText: "Cerrar",
            prevText: "<Ant",
            nextText: "Sig>",
            currentText: "Hoy",
            monthNames: [
                "enero",
                "febrero",
                "marzo",
                "abril",
                "mayo",
                "junio",
                "julio",
                "agosto",
                "septiembre",
                "octubre",
                "noviembre",
                "diciembre"
            ],
            monthNamesShort: ["ene", "feb", "mar", "abr", "may", "jun", "jul", "ago", "sep", "oct", "nov", "dic"],
            dayNames: ["domingo", "lunes", "martes", "miércoles", "jueves", "viernes", "sábado"],
            dayNamesShort: ["dom", "lun", "mar", "mié", "jue", "vie", "sáb"],
            dayNamesMin: ["D", "L", "M", "X", "J", "V", "S"],
            weekHeader: "Sm",
            dateFormat: "dd/mm/yy",
            firstDay: 1,
            isRTL: false,
            showMonthAfterYear: false,
            yearSuffix: "",
            timeOnlyTitle: "Elegir una hora",
            timeText: "Hora",
            hourText: "Horas",
            minuteText: "Minutos",
            secondText: "Segundos",
            millisecText: "Milisegundos",
            microsecText: "Microsegundos",
            timezoneText: "Uso horario",
            timeFormat: "HH:mm",
            timeSuffix: "",
            amNames: ["a.m.", "AM", "A"],
            pmNames: ["p.m.", "PM", "P"]
        };
        return _this;
    }
    BitCalendarComponent.prototype.ngOnInit = function () {
        this.yearRange = this.rangoAnyoMinimo + ":" + this.rangoAnyoMaximo;
    };
    BitCalendarComponent.ɵfac = function BitCalendarComponent_Factory(t) { return new (t || BitCalendarComponent)(i0.ɵɵdirectiveInject(i1.AyudaService), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
    BitCalendarComponent.ɵdir = i0.ɵɵdefineDirective({ type: BitCalendarComponent, inputs: { fechaMinima: "fechaMinima", fechaMaxima: "fechaMaxima", calendarReadOnlyInput: "calendarReadOnlyInput", rangoAnyoMinimo: "rangoAnyoMinimo", rangoAnyoMaximo: "rangoAnyoMaximo" }, features: [i0.ɵɵInheritDefinitionFeature] });
    return BitCalendarComponent;
}(bit_custom_component_1.BitCustomComponent));
exports.BitCalendarComponent = BitCalendarComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BitCalendarComponent, [{
        type: core_1.Directive
    }], function () { return [{ type: i1.AyudaService }, { type: i0.ChangeDetectorRef }]; }, { fechaMinima: [{
            type: core_2.Input
        }], fechaMaxima: [{
            type: core_2.Input
        }], calendarReadOnlyInput: [{
            type: core_2.Input
        }], rangoAnyoMinimo: [{
            type: core_2.Input
        }], rangoAnyoMaximo: [{
            type: core_2.Input
        }] }); })();
//# sourceMappingURL=bit-calendar.component.js.map