"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FocusRegisterDirective = void 0;
var core_1 = require("@angular/core");
var focus_service_1 = require("../service/focus.service");
var i0 = require("@angular/core");
var i1 = require("../service/focus.service");
var FocusRegisterDirective = /** @class */ (function () {
    function FocusRegisterDirective(elRef, renderer, focusService) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.focusService = focusService;
    }
    FocusRegisterDirective.prototype.onFocus = function () {
        this.focusService.focus(this.elRef.nativeElement.id);
    };
    FocusRegisterDirective.prototype.onBlur = function () {
        this.focusService.clear();
    };
    FocusRegisterDirective.ɵfac = function FocusRegisterDirective_Factory(t) { return new (t || FocusRegisterDirective)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.Renderer2), i0.ɵɵdirectiveInject(i1.FocusService)); };
    FocusRegisterDirective.ɵdir = i0.ɵɵdefineDirective({ type: FocusRegisterDirective, selectors: [["input"], ["select"], ["textarea"], ["bit-input"], ["bit-select"]], hostBindings: function FocusRegisterDirective_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("focus", function FocusRegisterDirective_focus_HostBindingHandler() { return ctx.onFocus(); })("blur", function FocusRegisterDirective_blur_HostBindingHandler() { return ctx.onBlur(); });
        } } });
    return FocusRegisterDirective;
}());
exports.FocusRegisterDirective = FocusRegisterDirective;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FocusRegisterDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "input,select,textarea,bit-input,bit-select" //TODO: no funciona bien con autoComplete. No se registra el focus
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: i1.FocusService }]; }, { onFocus: [{
            type: core_1.HostListener,
            args: ["focus"]
        }], onBlur: [{
            type: core_1.HostListener,
            args: ["blur"]
        }] }); })();
//# sourceMappingURL=focus-register.directive.js.map