"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DomainResolve = void 0;
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var domain_cached_service_1 = require("../service/domain-cached.service");
var i0 = require("@angular/core");
var i1 = require("../service/domain-cached.service");
var i2 = require("@angular/router");
var DomainResolve = /** @class */ (function () {
    function DomainResolve(service, router) {
        this.service = service;
        this.router = router;
    }
    /**
     * Permite obtener los datos del dominio de tipos de log de la cache de sessión o del servidor si no tuviéramos
     * los datos en caché
     */
    DomainResolve.prototype.resolve = function (route) {
        console.log("Resolviendo la precarga de datos");
        var dominios = route.data["dominios"];
        if (dominios == null) {
            console.log("No me ha llegado el dominio a cargar. No podemos retornar lista de valores");
            //return Promise.resolve([]);
        }
        var listaDominios = {};
        for (var _i = 0, dominios_1 = dominios; _i < dominios_1.length; _i++) {
            var dom = dominios_1[_i];
            //console.log("Vamos a recuperar el dominio, cacheado o no");
            var domServer = this.service.getDominio(dom);
            listaDominios[dom] = domServer;
        }
        return listaDominios;
    };
    DomainResolve.ɵfac = function DomainResolve_Factory(t) { return new (t || DomainResolve)(i0.ɵɵinject(i1.DomainCachedService), i0.ɵɵinject(i2.Router)); };
    DomainResolve.ɵprov = i0.ɵɵdefineInjectable({ token: DomainResolve, factory: DomainResolve.ɵfac });
    return DomainResolve;
}());
exports.DomainResolve = DomainResolve;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DomainResolve, [{
        type: core_1.Injectable
    }], function () { return [{ type: i1.DomainCachedService }, { type: i2.Router }]; }, null); })();
//# sourceMappingURL=domain.resolve.js.map