"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarService = void 0;
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var i0 = require("@angular/core");
var ToolbarService = /** @class */ (function () {
    function ToolbarService() {
        //private observableToolbarSource = new BehaviorSubject<any>(null);
        this.observableToolbarSource = new rxjs_1.ReplaySubject(10);
        console.log("ToolbarService creado");
        //el toolbar al suscribirse recibirá eiempre los últimos n mensajes (toolbar) enviados. Es para protegernos y garantizar que cuando un toolbar
        //se susbscribe después de que el componente padre envíe su toolbar, entonces si se cuelan delante más toolbars, al menos lo reciba
        //OJO!. Juntar share() con ReplaySubject o publishReplay hace que no se comporte como se esperaba
        this.observableToolbar = this.observableToolbarSource.asObservable(); //.share();//.publishReplay(3).refCount();
    }
    ToolbarService.prototype.updateToolbar = function (componentId, toolbar) {
        toolbar.componentId = componentId;
        this.observableToolbarSource.next(toolbar);
    };
    ToolbarService.ɵfac = function ToolbarService_Factory(t) { return new (t || ToolbarService)(); };
    ToolbarService.ɵprov = i0.ɵɵdefineInjectable({ token: ToolbarService, factory: ToolbarService.ɵfac });
    return ToolbarService;
}());
exports.ToolbarService = ToolbarService;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ToolbarService, [{
        type: core_1.Injectable
    }], function () { return []; }, null); })();
//# sourceMappingURL=toolbar.service.js.map