"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SharedModule = void 0;
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var http_1 = require("@angular/common/http");
var focus_register_directive_1 = require("./directive/focus-register.directive");
var fromComponents = require("./component");
var fromPipes = require("./pipe");
//import { SharedModule as primeSharedModule } from "primeng/shared";
var calendar_1 = require("primeng/calendar");
var dropdown_1 = require("primeng/dropdown");
var editor_1 = require("primeng/editor");
var multiselect_1 = require("primeng/multiselect");
var paginator_1 = require("primeng/paginator");
var checkbox_1 = require("primeng/checkbox");
var radiobutton_1 = require("primeng/radiobutton");
var tabview_1 = require("primeng/tabview");
var dialog_1 = require("primeng/dialog");
var accordion_1 = require("primeng/accordion");
var autocomplete_1 = require("primeng/autocomplete");
var inputswitch_1 = require("primeng/inputswitch");
var tooltip_1 = require("primeng/tooltip");
var overlaypanel_1 = require("primeng/overlaypanel");
var messages_1 = require("primeng/messages");
var api_1 = require("primeng/api");
var menu_1 = require("primeng/menu");
var menubar_1 = require("primeng/menubar");
var megamenu_1 = require("primeng/megamenu");
//import { GrowlModule } from "primeng/growl";
var table_1 = require("primeng/table");
var toast_1 = require("primeng/toast");
var ng2_file_upload_1 = require("ng2-file-upload");
var i0 = require("@angular/core");
var i1 = require("./component/form/bit-text.component");
var i2 = require("./component/form/bit-textarea.component");
var i3 = require("./component/form/bit-date.component");
var i4 = require("./component/form/bit-time.component");
var i5 = require("./component/form/bit-datetime.component");
var i6 = require("./component/form/bit-checkbox.component");
var i7 = require("./component/form/bit-switch.component");
var i8 = require("./component/form/bit-autocomplete.component");
var i9 = require("./component/form/bit-dropdown.component");
var i10 = require("./component/form/bit-dropdown-multiple.component");
var i11 = require("./component/form/bit-editor.component");
var i12 = require("./component/form/bit-readonly.component");
var i13 = require("./component/bit-dialog.component");
var i14 = require("./component/bit-notification.component");
var i15 = require("./component/bit-notification-front.component");
var i16 = require("./component/bit-control-messages.component");
var i17 = require("./component/bit-domain-value.component");
var i18 = require("./component/bit-column-boolean.component");
var i19 = require("./component/bit-footer.component");
var i20 = require("./component/bit-header.component");
var i21 = require("./component/bit-toolbar.component");
var i22 = require("./component/bit-breadcrumb.component");
var i23 = require("./component/bit-loading.component");
var i24 = require("./component/bit-upload.component");
var i25 = require("./component/bit-form-upload.component");
var i26 = require("./component/bit-help.component");
var i27 = require("./component/bit-user-controls.component");
var i28 = require("./component/bit-boton-ayuda.component");
var i29 = require("./component/bit-store-breadcrumb.component");
var i30 = require("./component/bit-store-header.component");
var i31 = require("./component/bit-store-footer.component");
var i32 = require("./component/bit-store-toolbar.component");
var i33 = require("./component/bit-ng-upload.component");
var i34 = require("./pipe/capitalize.pipe");
var i35 = require("./pipe/other-actions.pipe");
var i36 = require("./pipe/pipe-cantidadmoneda.pipe");
var i37 = require("./pipe/remove-line-breaks.pipe");
var modules = [
    common_1.CommonModule,
    forms_1.ReactiveFormsModule,
    forms_1.FormsModule,
    http_1.HttpClientModule,
    calendar_1.CalendarModule,
    dropdown_1.DropdownModule,
    editor_1.EditorModule,
    multiselect_1.MultiSelectModule,
    paginator_1.PaginatorModule,
    checkbox_1.CheckboxModule,
    radiobutton_1.RadioButtonModule,
    tabview_1.TabViewModule,
    dialog_1.DialogModule,
    menu_1.MenuModule,
    megamenu_1.MegaMenuModule,
    menubar_1.MenubarModule,
    toast_1.ToastModule,
    table_1.TableModule,
    //primeSharedModule,
    accordion_1.AccordionModule,
    autocomplete_1.AutoCompleteModule,
    inputswitch_1.InputSwitchModule,
    tooltip_1.TooltipModule,
    overlaypanel_1.OverlayPanelModule,
    messages_1.MessagesModule
];
var SharedModule = /** @class */ (function () {
    function SharedModule() {
    }
    SharedModule.ɵfac = function SharedModule_Factory(t) { return new (t || SharedModule)(); };
    SharedModule.ɵmod = i0.ɵɵdefineNgModule({ type: SharedModule });
    SharedModule.ɵinj = i0.ɵɵdefineInjector({ providers: [api_1.MessageService], imports: [__spreadArrays(modules, [ng2_file_upload_1.FileUploadModule]), common_1.CommonModule,
            forms_1.ReactiveFormsModule,
            forms_1.FormsModule,
            http_1.HttpClientModule,
            calendar_1.CalendarModule,
            dropdown_1.DropdownModule,
            editor_1.EditorModule,
            multiselect_1.MultiSelectModule,
            paginator_1.PaginatorModule,
            checkbox_1.CheckboxModule,
            radiobutton_1.RadioButtonModule,
            tabview_1.TabViewModule,
            dialog_1.DialogModule,
            menu_1.MenuModule,
            megamenu_1.MegaMenuModule,
            menubar_1.MenubarModule,
            toast_1.ToastModule,
            table_1.TableModule,
            //primeSharedModule,
            accordion_1.AccordionModule,
            autocomplete_1.AutoCompleteModule,
            inputswitch_1.InputSwitchModule,
            tooltip_1.TooltipModule,
            overlaypanel_1.OverlayPanelModule,
            messages_1.MessagesModule] });
    return SharedModule;
}());
exports.SharedModule = SharedModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(SharedModule, { declarations: [focus_register_directive_1.FocusRegisterDirective, i1.BitTextComponent, i2.BitTextAreaComponent, i3.BitDateComponent, i4.BitTimeComponent, i5.BitDateTimeComponent, i6.BitCheckBoxComponent, i7.BitSwitchComponent, i8.BitAutoCompleteComponent, i9.BitDropDownComponent, i10.BitDropDownMultipleComponent, i11.BitEditorComponent, i12.BitReadonlyComponent, i13.BitDialogComponent, i14.BitNotificationComponent, i15.BitNotificationFrontComponent, i15.BitNotificationFrontComponent, i16.BitControlMessages, i17.BitDomainValueComponent, i18.BitColumnBooleanComponent, i19.BitFooterComponent, i20.BitHeaderComponent, i21.BitToolbarComponent, i22.BitBreadCrumbComponent, i23.BitLoadingComponent, i24.BitUploadComponent, i25.BitFormUploadComponent, i26.BitHelpComponent, i27.BitUserControlsComponent, i28.BitBotonAyudaComponent, i29.BitStoreBreadCrumbComponent, i30.BitStoreHeaderComponent, i31.BitStoreFooterComponent, i32.BitStoreToolbarComponent, i33.BitNGUploadComponent, i34.CapitalizePipe, i35.OtherToolbarActionPipe, i36.PipeCantidadMoneda, i37.RemoveLineBreaksPipe], imports: [common_1.CommonModule,
        forms_1.ReactiveFormsModule,
        forms_1.FormsModule,
        http_1.HttpClientModule,
        calendar_1.CalendarModule,
        dropdown_1.DropdownModule,
        editor_1.EditorModule,
        multiselect_1.MultiSelectModule,
        paginator_1.PaginatorModule,
        checkbox_1.CheckboxModule,
        radiobutton_1.RadioButtonModule,
        tabview_1.TabViewModule,
        dialog_1.DialogModule,
        menu_1.MenuModule,
        megamenu_1.MegaMenuModule,
        menubar_1.MenubarModule,
        toast_1.ToastModule,
        table_1.TableModule,
        //primeSharedModule,
        accordion_1.AccordionModule,
        autocomplete_1.AutoCompleteModule,
        inputswitch_1.InputSwitchModule,
        tooltip_1.TooltipModule,
        overlaypanel_1.OverlayPanelModule,
        messages_1.MessagesModule, ng2_file_upload_1.FileUploadModule], exports: [common_1.CommonModule,
        forms_1.ReactiveFormsModule,
        forms_1.FormsModule,
        http_1.HttpClientModule,
        calendar_1.CalendarModule,
        dropdown_1.DropdownModule,
        editor_1.EditorModule,
        multiselect_1.MultiSelectModule,
        paginator_1.PaginatorModule,
        checkbox_1.CheckboxModule,
        radiobutton_1.RadioButtonModule,
        tabview_1.TabViewModule,
        dialog_1.DialogModule,
        menu_1.MenuModule,
        megamenu_1.MegaMenuModule,
        menubar_1.MenubarModule,
        toast_1.ToastModule,
        table_1.TableModule,
        //primeSharedModule,
        accordion_1.AccordionModule,
        autocomplete_1.AutoCompleteModule,
        inputswitch_1.InputSwitchModule,
        tooltip_1.TooltipModule,
        overlaypanel_1.OverlayPanelModule,
        messages_1.MessagesModule, focus_register_directive_1.FocusRegisterDirective, i34.CapitalizePipe, i35.OtherToolbarActionPipe, i36.PipeCantidadMoneda, i37.RemoveLineBreaksPipe, i1.BitTextComponent, i2.BitTextAreaComponent, i3.BitDateComponent, i4.BitTimeComponent, i5.BitDateTimeComponent, i6.BitCheckBoxComponent, i7.BitSwitchComponent, i8.BitAutoCompleteComponent, i9.BitDropDownComponent, i10.BitDropDownMultipleComponent, i11.BitEditorComponent, i12.BitReadonlyComponent, i13.BitDialogComponent, i14.BitNotificationComponent, i15.BitNotificationFrontComponent, i15.BitNotificationFrontComponent, i16.BitControlMessages, i17.BitDomainValueComponent, i18.BitColumnBooleanComponent, i19.BitFooterComponent, i20.BitHeaderComponent, i21.BitToolbarComponent, i22.BitBreadCrumbComponent, i23.BitLoadingComponent, i24.BitUploadComponent, i25.BitFormUploadComponent, i26.BitHelpComponent, i27.BitUserControlsComponent, i28.BitBotonAyudaComponent, i29.BitStoreBreadCrumbComponent, i30.BitStoreHeaderComponent, i31.BitStoreFooterComponent, i32.BitStoreToolbarComponent, i33.BitNGUploadComponent] }); })();
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SharedModule, [{
        type: core_1.NgModule,
        args: [{
                imports: __spreadArrays(modules, [ng2_file_upload_1.FileUploadModule]),
                declarations: __spreadArrays([focus_register_directive_1.FocusRegisterDirective], fromComponents.components, fromPipes.pipes),
                exports: __spreadArrays(modules, [focus_register_directive_1.FocusRegisterDirective], fromPipes.pipes, fromComponents.components),
                providers: [api_1.MessageService]
            }]
    }], null, null); })();
//# sourceMappingURL=shared.module.js.map