import { HttpInterceptor, HttpRequest, HttpHandler, HttpEvent } from "@angular/common/http";
import { Observable } from "rxjs";
import { MessageService } from "../service/message.service";
import { GeneralUtils } from "../service/general-utils.service";
import * as i0 from "@angular/core";
export declare class CustomHttpInterceptor implements HttpInterceptor {
    private messageService;
    private generalUtils;
    constructor(messageService: MessageService, generalUtils: GeneralUtils);
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
    static ɵfac: i0.ɵɵFactoryDef<CustomHttpInterceptor, never>;
    static ɵprov: i0.ɵɵInjectableDef<CustomHttpInterceptor>;
}
